﻿Imports Infragistics.Win.UltraWinToolbars
Imports System.ComponentModel

Public Class MyRibbonToolbar
    Inherits Infragistics.Win.UltraWinToolbars.UltraToolbarsManager


    Private meUseNABiStyle As ENUM_TRUEFALSE = ENUM_TRUEFALSE.FALSE

    <Flags> _
    Public Enum ENUM_TRUEFALSE
        [TRUE]
        [FALSE]
    End Enum

    <CategoryAttribute("My Design"), Browsable(True)> _
    Public Property UseRibbonStyle() As ENUM_TRUEFALSE

        Get
            Return meUseNABiStyle
        End Get
        Set(ByVal Value As ENUM_TRUEFALSE)
            meUseNABiStyle = Value

            ' *** Infragistics
            ' Don't add the tabs and stuff while initializing. 
            ' This will be handled in OnEndInit
            If (Not Me.isInitializing) Then
                If meUseNABiStyle = ENUM_TRUEFALSE.TRUE Then
                    SetRibbonStyle()
                End If
            End If

            InvalidateControls()

        End Set

    End Property


    ' *** Infragistics
    Private isInitializing As Boolean = False
    Protected Overrides Sub OnBeginInit()
        Me.isInitializing = True
        MyBase.OnBeginInit()
    End Sub
    Protected Overrides Sub OnEndInit()
        MyBase.OnEndInit()

        Me.isInitializing = False

        If Me.UseRibbonStyle = ENUM_TRUEFALSE.TRUE Then
            SetRibbonStyle()
        End If
    End Sub





    Private Sub SetRibbonStyle()
        Dim sButtonKey(2) As String
        Dim oButtonTool(2) As ButtonTool

        Dim sRibbonTabCaption() As String = {"Tab1", "Tab2", "Tab3", "Tab4"}
        Dim oRibbonKey(3) As String
        Dim oRibbonTab(3) As RibbonTab

        Dim oRibbonGroup1 As Infragistics.Win.UltraWinToolbars.RibbonGroup

        Try

            If Me.Ribbon.Visible = True Then
                Return
            End If

            'Show Ribbon
            Me.Ribbon.Visible = True

            ' *** Infragistics
            ' This is just quick and dirty. You probably want to check for the actual tabs
            ' by key using Me.Ribbon.Tabs.Exists(key)
            If (Me.Ribbon.Tabs.Count > 0) Then Return

            oRibbonGroup1 = New Infragistics.Win.UltraWinToolbars.RibbonGroup("ribbonGroup1")
            oRibbonGroup1.Caption = "Common"

            ''첫번재 Ribbon Tab에 공통 Button 3개 설정
            For iIndex As Integer = 0 To sButtonKey.Count - 1

                sButtonKey(iIndex) = "nabiButton" + iIndex.ToString
                oButtonTool(iIndex) = New Infragistics.Win.UltraWinToolbars.ButtonTool(sButtonKey(iIndex))
                oButtonTool(iIndex).SharedPropsInternal.Caption = sButtonKey(iIndex)
                oButtonTool(iIndex).InstanceProps.MinimumSizeOnRibbon = Infragistics.Win.UltraWinToolbars.RibbonToolSize.Large
                'Button 글자 색 지정
                oButtonTool(iIndex).SharedProps.AppearancesLarge.Appearance.ForeColor = Color.White
                oButtonTool(iIndex).SharedProps.AppearancesSmall.Appearance.ForeColor = Color.White

                oRibbonGroup1.Tools.Add(oButtonTool(iIndex))

            Next

            'Set Ribbon Tab (4)
            For iIndex As Integer = 0 To oRibbonTab.Count - 1


                oRibbonKey(iIndex) = "nabiRibbonTab" + iIndex.ToString

                'delete RibbonTab key 
                If Me.Ribbon.Tabs.Exists(oRibbonKey(iIndex)) Then
                    Me.Ribbon.Tabs.Remove(oRibbonKey(iIndex))
                End If

                oRibbonTab(iIndex) = New Infragistics.Win.UltraWinToolbars.RibbonTab(oRibbonKey(iIndex))
                oRibbonTab(iIndex).Caption = sRibbonTabCaption(iIndex)

                'Tab 글자 색 지정
                oRibbonTab(iIndex).Settings.Appearance.ForeColor = Color.White
            Next



            oRibbonTab(0).Groups.AddRange(New Infragistics.Win.UltraWinToolbars.RibbonGroup() {oRibbonGroup1})


            If Me.Ribbon.Tabs.Count < 3 Then

                'NonInheritedRibbonTabs.Add
                'Me.Ribbon.NonInheritedRibbonTabs.AddRange(New Infragistics.Win.UltraWinToolbars.RibbonTab() {oRibbonTab(0), oRibbonTab(1), oRibbonTab(2), oRibbonTab(3)})
                If Not Me.Ribbon.Tabs.Exists(oRibbonTab(1).Key) Then
                    Me.Ribbon.Tabs.AddRange(New Infragistics.Win.UltraWinToolbars.RibbonTab() {oRibbonTab(0), oRibbonTab(1), oRibbonTab(2), oRibbonTab(3)})

                End If
            End If


        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try

    End Sub

End Class
